OpenShot Audio Library | OpenShotAudio: juce::InputStream Class Reference

OpenShot Audio Library | OpenShotAudio 1.0.0

Loading...
Searching...
No Matches
juce::InputStream Class Referenceabstract

`#include <juce_InputStream.h>`

Inheritance diagram for juce::InputStream:

## Public Member Functions
virtual | ~InputStream ()=default
virtual int64 | getTotalLength ()=0
int64 | getNumBytesRemaining ()
virtual bool | isExhausted ()=0
virtual int | read (void *destBuffer, int maxBytesToRead)=0
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
virtual bool | readBool ()
virtual short | readShort ()
virtual short | readShortBigEndian ()
virtual int | readInt ()
virtual int | readIntBigEndian ()
virtual int64 | readInt64 ()
virtual int64 | readInt64BigEndian ()
virtual float | readFloat ()
virtual float | readFloatBigEndian ()
virtual double | readDouble ()
virtual double | readDoubleBigEndian ()
virtual int | readCompressedInt ()
virtual String | readNextLine ()
virtual String | readString ()
virtual String | readEntireStreamAsString ()
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
virtual int64 | getPosition ()=0
virtual bool | setPosition (int64 newPosition)=0
virtual void | skipNextBytes (int64 numBytesToSkip)

## Detailed Description

The base class for streams that read data.

Input and output streams are used throughout the library - subclasses can override some or all of the virtual functions to implement their behaviour.

See also
  OutputStream, MemoryInputStream, BufferedInputStream, FileInputStream

Definition at line 36 of file juce_InputStream.h.

## Constructor & Destructor Documentation

## ◆ ~InputStream()

virtual juce::InputStream::~InputStream | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ getNumBytesRemaining()

int64 juce::InputStream::getNumBytesRemaining | ( |  | ) |

Returns the number of bytes available for reading, or a negative value if the remaining length is not known.

See also
  getTotalLength

Definition at line 26 of file juce_InputStream.cpp.

Referenced by getTotalLength().

## ◆ getPosition()

virtual int64 juce::InputStream::getPosition | ( |  | ) |
| pure virtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implemented in juce::BufferedInputStream, juce::FileInputStream, juce::GZIPDecompressorInputStream, juce::MemoryInputStream, juce::SubregionStream, and juce::WebInputStream.

Referenced by getNumBytesRemaining(), readNextLine(), and juce::MemoryOutputStream::writeFromInputStream().

## ◆ getTotalLength()

virtual int64 juce::InputStream::getTotalLength | ( |  | ) |
| pure virtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implemented in juce::BufferedInputStream, juce::FileInputStream, juce::GZIPDecompressorInputStream, juce::MemoryInputStream, juce::SubregionStream, and juce::WebInputStream.

Referenced by getNumBytesRemaining(), and juce::MemoryOutputStream::writeFromInputStream().

## ◆ isExhausted()

virtual bool juce::InputStream::isExhausted | ( |  | ) |
| pure virtual

Returns true if the stream has no more data to read.

Implemented in juce::BufferedInputStream, juce::FileInputStream, juce::GZIPDecompressorInputStream, juce::MemoryInputStream, juce::SubregionStream, and juce::WebInputStream.

Referenced by skipNextBytes().

## ◆ read() [1/2]

virtual int juce::InputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead )
| pure virtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implemented in juce::BufferedInputStream, juce::FileInputStream, juce::GZIPDecompressorInputStream, juce::MemoryInputStream, juce::SubregionStream, and juce::WebInputStream.

Referenced by read(), readByte(), readCompressedInt(), juce::var::readFromStream(), readInt(), readInt64(), readInt64BigEndian(), readIntBigEndian(), readShort(), readShortBigEndian(), skipNextBytes(), and juce::OutputStream::writeFromInputStream().

## ◆ read() [2/2]

ssize_t juce::InputStream::read | ( | void * | destBuffer,
|  | size_t | maxBytesToRead )

Definition at line 36 of file juce_InputStream.cpp.

## ◆ readBool()

bool juce::InputStream::readBool | ( |  | ) |
| virtual

Reads a boolean from the stream. The bool is encoded as a single byte - non-zero for true, 0 for false. If the stream is exhausted, this will return false.

See also
  OutputStream::writeBool

Definition at line 63 of file juce_InputStream.cpp.

Referenced by read().

## ◆ readByte()

char juce::InputStream::readByte | ( |  | ) |
| virtual

Reads a byte from the stream. If the stream is exhausted, this will return zero.

See also
  OutputStream::writeByte

Definition at line 56 of file juce_InputStream.cpp.

Referenced by juce::ValueTreeSynchroniser::applyChange(), read(), readBool(), readCompressedInt(), juce::var::readFromStream(), readNextLine(), readString(), and juce::FileLogger::trimFileSize().

## ◆ readCompressedInt()

int juce::InputStream::readCompressedInt | ( |  | ) |
| virtual

Reads an encoded 32-bit number from the stream using a space-saving compressed format. For small values, this is more space-efficient than using readInt() and OutputStream::writeInt() The format used is: number of significant bytes + up to 4 bytes in little-endian order.

See also
  OutputStream::writeCompressedInt()

Definition at line 108 of file juce_InputStream.cpp.

Referenced by juce::ValueTreeSynchroniser::applyChange(), read(), juce::ValueTree::readFromStream(), and juce::var::readFromStream().

## ◆ readDouble()

double juce::InputStream::readDouble | ( |  | ) |
| virtual

Reads eight bytes as a 64-bit floating point value. The raw 64-bit encoding of the double is read from the stream as a little-endian int64. If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeDouble, readFloat

Definition at line 168 of file juce_InputStream.cpp.

Referenced by read(), and juce::var::readFromStream().

## ◆ readDoubleBigEndian()

double juce::InputStream::readDoubleBigEndian | ( |  | ) |
| virtual

Reads eight bytes as a 64-bit floating point value. The raw 64-bit encoding of the double is read from the stream as a big-endian int64. If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeDoubleBigEndian, readFloatBigEndian

Definition at line 175 of file juce_InputStream.cpp.

Referenced by read().

## ◆ readEntireStreamAsString()

String juce::InputStream::readEntireStreamAsString | ( |  | ) |
| virtual

Tries to read the whole stream and turn it into a string.

This will read from the stream's current position until the end-of-stream. It can read from UTF-8 data, or UTF-16 if it detects suitable header-bytes.

Definition at line 229 of file juce_InputStream.cpp.

Referenced by juce::File::loadFileAsString(), juce::JSON::parse(), and read().

## ◆ readFloat()

float juce::InputStream::readFloat | ( |  | ) |
| virtual

Reads four bytes as a 32-bit floating point value. The raw 32-bit encoding of the float is read from the stream as a little-endian int. If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeFloat, readDouble

Definition at line 153 of file juce_InputStream.cpp.

Referenced by read().

## ◆ readFloatBigEndian()

float juce::InputStream::readFloatBigEndian | ( |  | ) |
| virtual

Reads four bytes as a 32-bit floating point value. The raw 32-bit encoding of the float is read from the stream as a big-endian int. If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeFloatBigEndian, readDoubleBigEndian

Definition at line 161 of file juce_InputStream.cpp.

Referenced by read().

## ◆ readInt()

int juce::InputStream::readInt | ( |  | ) |
| virtual

Reads four bytes from the stream as a little-endian 32-bit value.

If the next four bytes are byte1 to byte4, this returns (byte1 | (byte2 << 8) | (byte3 << 16) | (byte4 << 24)).

If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeInt, readIntBigEndian

Definition at line 88 of file juce_InputStream.cpp.

Referenced by read(), readFloat(), and juce::var::readFromStream().

## ◆ readInt64()

int64 juce::InputStream::readInt64 | ( |  | ) |
| virtual

Reads eight bytes from the stream as a little-endian 64-bit value.

If the next eight bytes are byte1 to byte8, this returns (byte1 | (byte2 << 8) | (byte3 << 16) | (byte4 << 24) | (byte5 << 32) | (byte6 << 40) | (byte7 << 48) | (byte8 << 56)).

If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeInt64, readInt64BigEndian

Definition at line 133 of file juce_InputStream.cpp.

Referenced by read(), readDouble(), and juce::var::readFromStream().

## ◆ readInt64BigEndian()

int64 juce::InputStream::readInt64BigEndian | ( |  | ) |
| virtual

Reads eight bytes from the stream as a big-endian 64-bit value.

If the next eight bytes are byte1 to byte8, this returns (byte8 | (byte7 << 8) | (byte6 << 16) | (byte5 << 24) | (byte4 << 32) | (byte3 << 40) | (byte2 << 48) | (byte1 << 56)).

If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeInt64BigEndian, readInt64

Definition at line 143 of file juce_InputStream.cpp.

Referenced by read(), and readDoubleBigEndian().

## ◆ readIntBigEndian()

int juce::InputStream::readIntBigEndian | ( |  | ) |
| virtual

Reads four bytes from the stream as a big-endian 32-bit value.

If the next four bytes are byte1 to byte4, this returns (byte4 | (byte3 << 8) | (byte2 << 16) | (byte1 << 24)).

If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeIntBigEndian, readInt

Definition at line 98 of file juce_InputStream.cpp.

Referenced by read(), and readFloatBigEndian().

## ◆ readIntoMemoryBlock()

size_t juce::InputStream::readIntoMemoryBlock | ( | MemoryBlock & | destBlock,
|  | ssize_t | maxNumBytesToRead = -1 )
| virtual

Reads from the stream and appends the data to a MemoryBlock.

Parameters

  destBlock | the block to append the data onto
  maxNumBytesToRead | if this is a positive value, it sets a limit to the number of bytes that will be read - if it's negative, data will be read until the stream is exhausted.

Returns
  the number of bytes that were added to the memory block

Definition at line 223 of file juce_InputStream.cpp.

Referenced by juce::File::loadFileAsData(), read(), and juce::MidiFile::readFrom().

## ◆ readNextLine()

String juce::InputStream::readNextLine | ( |  | ) |
| virtual

Reads a UTF-8 string from the stream, up to the next linefeed or carriage return.

This will read up to the next "\n" or "\r\n" or end-of-stream.

After this call, the stream's position will be left pointing to the next character following the line-feed, but the linefeeds aren't included in the string that is returned.

Definition at line 196 of file juce_InputStream.cpp.

Referenced by read().

## ◆ readShort()

short juce::InputStream::readShort | ( |  | ) |
| virtual

Reads two bytes from the stream as a little-endian 16-bit value. If the next two bytes read are byte1 and byte2, this returns (byte1 | (byte2 << 8)). If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeShort, readShortBigEndian

Definition at line 68 of file juce_InputStream.cpp.

Referenced by read().

## ◆ readShortBigEndian()

short juce::InputStream::readShortBigEndian | ( |  | ) |
| virtual

Reads two bytes from the stream as a little-endian 16-bit value. If the next two bytes read are byte1 and byte2, this returns (byte2 | (byte1 << 8)). If the stream is exhausted partway through reading the bytes, this will return zero.

See also
  OutputStream::writeShortBigEndian, readShort

Definition at line 78 of file juce_InputStream.cpp.

Referenced by read().

## ◆ readString()

String juce::InputStream::readString | ( |  | ) |
| virtual

Reads a zero-terminated UTF-8 string from the stream.

This will read characters from the stream until it hits a null character or end-of-stream.

See also
  OutputStream::writeString, readEntireStreamAsString

Reimplemented in juce::BufferedInputStream.

Definition at line 182 of file juce_InputStream.cpp.

Referenced by juce::ValueTreeSynchroniser::applyChange(), read(), juce::ValueTree::readFromStream(), and juce::BufferedInputStream::readString().

## ◆ setPosition()

virtual bool juce::InputStream::setPosition | ( | int64 | newPosition | ) |
| pure virtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implemented in juce::BufferedInputStream, juce::FileInputStream, juce::GZIPDecompressorInputStream, juce::MemoryInputStream, juce::SubregionStream, and juce::WebInputStream.

Referenced by readNextLine().

## ◆ skipNextBytes()

void juce::InputStream::skipNextBytes | ( | int64 | numBytesToSkip | ) |
| virtual

Reads and discards a number of bytes from the stream.

Some input streams might implement this more efficiently, but the base class will just keep reading data until the requisite number of bytes have been done. For large skips it may be quicker to call setPosition() with the required position.

Reimplemented in juce::MemoryInputStream.

Definition at line 237 of file juce_InputStream.cpp.

Referenced by juce::var::readFromStream(), juce::GZIPDecompressorInputStream::setPosition(), and setPosition().

The documentation for this class was generated from the following files:

- juce_InputStream.h
- juce_InputStream.cpp